<?php
/**
 * Created by PhpStorm.
 * User: robin
 * Date: 10/1/16
 * Time: 5:33 PM
 */

namespace App\Controller;

use App\Business\SchedulesBusiness;
use App\Dbo\StopsLiteRoutesLiteDboArray;
use Luticate\Utils\Controller\LuController;
use Luticate\Utils\Dbo\LuDateTimeDbo;
use Luticate\Utils\Dbo\LuIntDbo;
use Luticate\Utils\Dbo\LuPaginatedDbo;

class SchedulesController extends LuController
{
    protected function getBusiness()
    {
        return new SchedulesBusiness();
    }

    /**
     * Get schedules for multiple stops/routes
     * @param StopsLiteRoutesLiteDboArray $stops The stops and routes to retrieve
     * @param LuDateTimeDbo $date The date to get the schedules
     * @param LuIntDbo $count The maximum number of schedules per stops/routes
     * @return LuPaginatedDbo
     */
    public function getMultiple(StopsLiteRoutesLiteDboArray $stops, LuDateTimeDbo $date, LuIntDbo $count)
    {
        return static::getBusiness()->getMultiple($stops, $date->getDateTime(), $count->getInt());
    }
}