<?php
/**
 * Created by PhpStorm.
 * User: robin
 * Date: 10/3/16
 * Time: 6:07 PM
 */

namespace App\Controller;


use App\Business\UsersSettingsBusiness;
use Luticate\Utils\Dbo\LuStringDbo;

class UsersSettingsController
{
    public function getBusiness()
    {
        return new UsersSettingsBusiness();
    }

    /**
     * Set the encrypted settings to be saved
     * @param LuStringDbo $settings The encrypted settings
     * @param LuStringDbo $id The user facebook id
     * @trim
     * @min 1
     * @return bool
     */
    public function put(LuStringDbo $settings, LuStringDbo $id)
    {
        return static::getBusiness()->put($settings->getString(), $id->getString());
    }

    /**
     * Get the previously saved encrypted settings
     * @param LuStringDbo $id The user facebook id
     * @trim
     * @min 1
     * @return string
     */
    public function get(LuStringDbo $id)
    {
        return static::getBusiness()->get($id->getString());
    }
}